package lib;

import lib.Vec.Vec2;

/**
	Reporesents a Point in a 2D `Int` System.
	Basicly a wrapper for Vec2<Int> with some extra functions.
**/
@:forward(x, y)
abstract ScreenPos(Vec2<Int>) from Vec2<Int> to Vec2<Int> {
	inline public function new(i:Vec2<Int>) {
		this = i;
	}

	@:op(A + B)
	public inline function add(rhs:Vec2<Int>):ScreenPos {
		return this.add(rhs);
	}

	@:op(A - B)
	public inline function sub(rhs:Vec2<Int>):ScreenPos {
		return this.sub(rhs);
	}

	@:op(A * B)
	public inline function multiply(rhs:Vec2<Int>):ScreenPos {
		return this.multiply(rhs);
	}

	@:op(-A)
	public inline function negate():ScreenPos {
		return this.negate();
	}
}
